/*****************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
ե̾: keyboard.c
⥸塼̾ : keyboard
ǽ: ܡ(ɽ)˴ؤ
: ʡϺ
ѹ: ã
*****************************************************************************/

#ifdef	NO_CURSES
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#include "yumihead.h"

#define LEFT_KO  	1
#define LEFT_KU		2
#define LEFT_NA  	3
#define LEFT_HI  	4
#define LEFT_O  	5
#define RIGHT_O  	6
#define RIGHT_HI  	7
#define RIGHT_NA  	8
#define RIGHT_KU  	9
#define RIGHT_KO  	10

makekeyboard()
{
	switch(keyboard) {
        case KEYBOARD_LUNA:
		luna_makekeyboard();
		break;
	default:
	case KEYBOARD_NEWS:
		news_makekeyboard();
		break;
	case KEYBOARD_RIOS:
		rios_makekeyboard();
		break;
	}
}

luna_makekeyboard()
{
	mvaddstr( 3,10,"-------------------------------------------------------------");
	mvaddstr( 4,10,"|ESC| 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | ^ | \\ |BS |");
	mvaddstr( 5,10,"-------------------------------------------------------------");
	mvaddstr( 6,10,"|TAB  | Q | W | E | R | T | Y | U | I | O | P | @ | [ |     |");
	mvaddstr( 7,10,"--------------------------------------------------------    |");
	mvaddstr( 8,10,"|CTRL   | A | S | D | F | G | H | J | K | L | ; | : | ] |   |");
	mvaddstr( 9,10,"-------------------------------------------------------------");
	mvaddstr(10,10,"|SHIFT    | Z | X | C | V | B | N | M | , | . | / | _ |SHIFT|");
	mvaddstr(11,10,"-------------------------------------------------------------");
	mvaddstr(12,18,        "|   |   |   |      SPACE          |     |");
	mvaddstr(13,18,        "-----------------------------------------");
}

news_makekeyboard()
{
	mvaddstr( 3,10,"-------------------------------------------------------------");
	mvaddstr( 4,10,"|ESC| 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | = | \\ |BS |");
	mvaddstr( 5,10,"-------------------------------------------------------------");
	mvaddstr( 6,10,"|TAB  | Q | W | E | R | T | Y | U | I | O | P | [ | ] |     |");
	mvaddstr( 7,10,"--------------------------------------------------------    |");
	mvaddstr( 8,10,"|CTRL   | A | S | D | F | G | H | J | K | L | ; | ' | ` |   |");
	mvaddstr( 9,10,"-------------------------------------------------------------");
	mvaddstr(10,10,"|SHIFT    | Z | X | C | V | B | N | M | , | . | / |   |SHIFT|");
	mvaddstr(11,10,"-------------------------------------------------------------");
	mvaddstr(12,18,        "|   |   |   |      SPACE          |     |");
	mvaddstr(13,18,        "-----------------------------------------");
}

rios_makekeyboard()
{
	mvaddstr( 3,10,"-------------------------------------------------------------");
	mvaddstr( 4,10,"| ` | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | = |  BS   |");
	mvaddstr( 5,10,"-------------------------------------------------------------");
	mvaddstr( 6,10,"|TAB  | Q | W | E | R | T | Y | U | I | O | P | [ | ] |  \\  |");
	mvaddstr( 7,10,"------------------------------------------------------------|");
	mvaddstr( 8,10,"|CTRL   | A | S | D | F | G | H | J | K | L | ; | ' |       |");
	mvaddstr( 9,10,"-------------------------------------------------------------");
	mvaddstr(10,10,"|SHIFT    | Z | X | C | V | B | N | M | , | . | / |  SHIFT  |");
	mvaddstr(11,10,"-------------------------------------------------------------");
	mvaddstr(12,18,        "|      |           SPACE          |      |");
	mvaddstr(13,18,        "------------------------------------------");
}

k_makekeyboard()
{
	mvaddstr(3, 10, "-------------------------------------------------------------");
	mvaddstr(4, 10, "|ESC| | | | | | | | | | | | | |BS |");
	mvaddstr(5, 10, "-------------------------------------------------------------");
	mvaddstr(6, 10, "|TAB  | | | | | | | | | | | | |     |");
	mvaddstr(7, 10, "--------------------------------------------------------    |");
	mvaddstr(8, 10, "|CTRL   | | | | | | | | | | | | |   |");
	mvaddstr(9, 10, "-------------------------------------------------------------");
	mvaddstr(10, 10,"|SHIFT    | | | | | | | | | | | |SHIFT|");
	mvaddstr(11, 10,"-------------------------------------------------------------");
	mvaddstr(12, 18,        "|   |   |   |      SPACE          |     |");
	mvaddstr(13, 18,        "-----------------------------------------");
}

keyreverse(ch)
int ch;
{
	standout();
	keyclear(ch);
	standend();
}


k_keyreverse(ch)
int	ch;
{
	standout();
	k_keyclear();
	standend();
}

keyclear(ch)
int ch;
{
	switch(keyboard) {
        case KEYBOARD_LUNA:
		luna_keyclear(ch);
		break;
	default:
	case KEYBOARD_RIOS:
	case KEYBOARD_NEWS:
		news_keyclear(ch);
		break;
	}
}

luna_keyclear(ch)
int ch;
{
	int shift;
	int ctrl;
	int f;

	shift = FALSE;
	ctrl = FALSE;
	if ('A' <= ch && ch <= 'Z') {
		shift = TRUE;
		ch = ch + ('a' - 'A');
	}
	if (ch == 0) {
		ctrl = TRUE;
		ch = ' ';
	}
	else if (ch < ' ' && (ch != '\r') && (ch != 0x08) && (ch != '\t') && (ch != 27)) {
		ctrl = TRUE;
		ch = ch + '@';
	}
	switch(ch) {
	case 27:  mvaddstr(4, 11, "ESC"); break;
	case '!': shift = TRUE;
	case '1': mvaddstr(4, 15, " 1 "); break;
	case '"': shift = TRUE;
	case '2': mvaddstr(4, 19, " 2 "); break;
	case '#': shift = TRUE;
	case '3': mvaddstr(4, 23, " 3 "); break;
	case '$': shift = TRUE;
	case '4': mvaddstr(4, 27, " 4 "); break;
	case '%': shift = TRUE;
	case '5': mvaddstr(4, 31, " 5 "); break;
	case '&': shift = TRUE;
	case '6': mvaddstr(4, 35, " 6 "); break;
	case '\'': shift = TRUE;
	case '7': mvaddstr(4, 39, " 7 "); break;
	case '(': shift = TRUE;
	case '8': mvaddstr(4, 43, " 8 "); break;
	case ')': shift = TRUE;
	case '9': mvaddstr(4, 47, " 9 "); break;
	case '0': mvaddstr(4, 51, " 0 "); break;
	case '=': shift = TRUE;
	case '-': mvaddstr(4, 55, " - "); break;
	case '~': shift = TRUE;
	case '^': mvaddstr(4, 59, " ^ "); break;
	case '|': shift = TRUE;
	case '\\': mvaddstr(4, 63, " \\ "); break;
	case 0x08: mvaddstr(4, 67, "BS "); break;
	case '\t': mvaddstr(6, 11, "TAB  "); break;
	case 'q': mvaddstr(6, 17, " Q "); break;
	case 'w': mvaddstr(6, 21, " W "); break;
	case 'e': mvaddstr(6, 25, " E "); break;
	case 'r': mvaddstr(6, 29, " R "); break;
	case 't': mvaddstr(6, 33, " T "); break;
	case 'y': mvaddstr(6, 37, " Y "); break;
	case 'u': mvaddstr(6, 41, " U "); break;
	case 'i': mvaddstr(6, 45, " I "); break;
	case 'o': mvaddstr(6, 49, " O "); break;
	case 'p': mvaddstr(6, 53, " P "); break;
	case '`': shift = TRUE;
	case '@': mvaddstr(6, 57, " @ "); break;
	case '{': shift = TRUE;
	case '[': mvaddstr(6, 61, " [ "); break;
	case 'a': mvaddstr(8, 19, " A "); break;
	case 's': mvaddstr(8, 23, " S "); break;
	case 'd': mvaddstr(8, 27, " D "); break;
	case 'f': mvaddstr(8, 31, " F "); break;
	case 'g': mvaddstr(8, 35, " G "); break;
	case 'h': mvaddstr(8, 39, " H "); break;
	case 'j': mvaddstr(8, 43, " J "); break;
	case 'k': mvaddstr(8, 47, " K "); break;
	case 'l': mvaddstr(8, 51, " L "); break;
	case '+': shift = TRUE;
	case ';': mvaddstr(8, 55, " ; "); break;
	case '*': shift = TRUE;
	case ':': mvaddstr(8, 59, " : "); break;
	case '}': shift = TRUE;
	case ']': mvaddstr(8, 63, " ] "); break;
	case 'z': mvaddstr(10, 21, " Z "); break;
	case 'x': mvaddstr(10, 25, " X "); break;
	case 'c': mvaddstr(10, 29, " C "); break;
	case 'v': mvaddstr(10, 33, " V "); break;
	case 'b': mvaddstr(10, 37, " B "); break;
	case 'n': mvaddstr(10, 41, " N "); break;
	case 'm': mvaddstr(10, 45, " M "); break;
	case '<': shift = TRUE;
	case ',': mvaddstr(10, 49, " , "); break;
	case '>': shift = TRUE;
	case '.': mvaddstr(10, 53, " . "); break;
	case '?': shift = TRUE;
	case '/': mvaddstr(10, 57, " / "); break;
	case '_': mvaddstr(10, 61, " _ "); break;
	case 0x0d:
		mvaddstr(6, 65, "     ");
		mvaddstr(7, 67, "   ");
		mvaddstr(8, 67, "   ");
		break;
	case ' ':
		mvaddstr(12, 32, "      SPACE         ");
		break;
	default:
		break;
	}
	if (ctrl) mvaddstr(8, 11, "CTRL   ");
	if (shift) {
		f = -finger(ch);
		if (RIGHT_O <= f && f <= RIGHT_KO) {
			mvaddstr(10, 11, "SHIFT    ");
		}
		else {
			mvaddstr(10, 65, "SHIFT");
		}
	}
}

news_keyclear(ch)
int ch;
{
	int shift;
	int ctrl;
	int f;

	shift = FALSE;
	ctrl = FALSE;
	if ('A' <= ch && ch <= 'Z') {
		shift = TRUE;
		ch = ch + ('a' - 'A');
	}
	if (ch == 0) {
		ctrl = TRUE;
		ch = ' ';
	}
	else if (ch < ' ' && (ch != '\r') && (ch != 0x08) && (ch != '\t') && (ch != 27)) {
		ctrl = TRUE;
		ch = ch + '@';
	}
	switch(ch) {
	case 27:  mvaddstr(4, 11, "ESC"); break;
	case '!': shift = TRUE;
	case '1': mvaddstr(4, 15, " 1 "); break;
	case '@': shift = TRUE;
	case '2': mvaddstr(4, 19, " 2 "); break;
	case '#': shift = TRUE;
	case '3': mvaddstr(4, 23, " 3 "); break;
	case '$': shift = TRUE;
	case '4': mvaddstr(4, 27, " 4 "); break;
	case '%': shift = TRUE;
	case '5': mvaddstr(4, 31, " 5 "); break;
	case '^': shift = TRUE;
	case '6': mvaddstr(4, 35, " 6 "); break;
	case '&': shift = TRUE;
	case '7': mvaddstr(4, 39, " 7 "); break;
	case '*': shift = TRUE;
	case '8': mvaddstr(4, 43, " 8 "); break;
	case '(': shift = TRUE;
	case '9': mvaddstr(4, 47, " 9 "); break;
	case ')': shift = TRUE;
	case '0': mvaddstr(4, 51, " 0 "); break;
	case '_': shift = TRUE;
	case '-': mvaddstr(4, 55, " - "); break;
	case '+': shift = TRUE;
	case '=': mvaddstr(4, 59, " ^ "); break;
	case '|': shift = TRUE;
	case '\\': 
		if (keyboard == KEYBOARD_RIOS) mvaddstr(6, 65, " \\ "); 
	        else mvaddstr(4, 63, " \\ ");
	        break;
	case 0x08:
	        if (keyboard == KEYBOARD_RIOS) mvaddstr(4, 67, " BS  ");
	        else mvaddstr(4, 67, "BS ");
	        break;
	case '\t': mvaddstr(6, 11, "TAB  "); break;
	case 'q': mvaddstr(6, 17, " Q "); break;
	case 'w': mvaddstr(6, 21, " W "); break;
	case 'e': mvaddstr(6, 25, " E "); break;
	case 'r': mvaddstr(6, 29, " R "); break;
	case 't': mvaddstr(6, 33, " T "); break;
	case 'y': mvaddstr(6, 37, " Y "); break;
	case 'u': mvaddstr(6, 41, " U "); break;
	case 'i': mvaddstr(6, 45, " I "); break;
	case 'o': mvaddstr(6, 49, " O "); break;
	case 'p': mvaddstr(6, 53, " P "); break;
	case '{': shift = TRUE;
	case '[': mvaddstr(6, 57, " [ "); break;
	case '}': shift = TRUE;
	case ']': mvaddstr(6, 61, " ] "); break;
	case 'a': mvaddstr(8, 19, " A "); break;
	case 's': mvaddstr(8, 23, " S "); break;
	case 'd': mvaddstr(8, 27, " D "); break;
	case 'f': mvaddstr(8, 31, " F "); break;
	case 'g': mvaddstr(8, 35, " G "); break;
	case 'h': mvaddstr(8, 39, " H "); break;
	case 'j': mvaddstr(8, 43, " J "); break;
	case 'k': mvaddstr(8, 47, " K "); break;
	case 'l': mvaddstr(8, 51, " L "); break;
	case ':': shift = TRUE;
	case ';': mvaddstr(8, 55, " ; "); break;
	case '"': shift = TRUE;
	case '\'': mvaddstr(8, 59, " ' "); break;
	case '~': shift = TRUE;
	case '`': mvaddstr(8, 63, " ` "); break;
	case 'z': mvaddstr(10, 21, " Z "); break;
	case 'x': mvaddstr(10, 25, " X "); break;
	case 'c': mvaddstr(10, 29, " C "); break;
	case 'v': mvaddstr(10, 33, " V "); break;
	case 'b': mvaddstr(10, 37, " B "); break;
	case 'n': mvaddstr(10, 41, " N "); break;
	case 'm': mvaddstr(10, 45, " M "); break;
	case '<': shift = TRUE;
	case ',': mvaddstr(10, 49, " , "); break;
	case '>': shift = TRUE;
	case '.': mvaddstr(10, 53, " . "); break;
	case '?': shift = TRUE;
	case '/': mvaddstr(10, 57, " / "); break;
	case 0x0d:
		mvaddstr(6, 65, "     ");
		mvaddstr(7, 67, "   ");
		mvaddstr(8, 67, "   ");
		break;
	case ' ':
		mvaddstr(12, 32, "      SPACE         ");
		break;
	default:
		break;
	}
	if (ctrl) mvaddstr(8, 11, "CTRL   ");
	if (shift) {
		f = -finger(ch);
		if (RIGHT_O <= f && f <= RIGHT_KO) {
			mvaddstr(10, 11, "SHIFT    ");
		}
		else {
			mvaddstr(10, 65, "SHIFT");
		}
	}
}

k_keyclear(ch)
int	ch;
{
	switch(ch){
	case 0xc7: mvaddstr(4, 15, " "); break;
	case 0xcc: mvaddstr(4, 19, " "); break;
	case 0xb1: mvaddstr(4, 23, " "); break;
	case 0xb3: mvaddstr(4, 27, " "); break;
	case 0xb4: mvaddstr(4, 31, " "); break;
	case 0xb5: mvaddstr(4, 35, " "); break;
	case 0xd4: mvaddstr(4, 39, " "); break;
	case 0xd5: mvaddstr(4, 43, " "); break;
	case 0xd6: mvaddstr(4, 47, " "); break;
	case 0xdc: mvaddstr(4, 51, " "); break;
	case 0xce: mvaddstr(4, 55, " "); break;
	case 0xcd: mvaddstr(4, 59, " "); break;
	case 0xb0: mvaddstr(4, 63, "   "); break;
	case 0xc0: mvaddstr(6, 17, " "); break;
	case 0xc3: mvaddstr(6, 21, " "); break;
	case 0xb2: mvaddstr(6, 25, " "); break;
	case 0xbd: mvaddstr(6, 29, " "); break;
	case 0xb6: mvaddstr(6, 33, " "); break;
	case 0xdd: mvaddstr(6, 37, " "); break;
	case 0xc5: mvaddstr(6, 41, " "); break;
	case 0xc6: mvaddstr(6, 45, " "); break;
	case 0xd7: mvaddstr(6, 49, " "); break;
	case 0xbe: mvaddstr(6, 53, " "); break;
	case 0xde: mvaddstr(6, 57, " "); break;
	case 0xdf: mvaddstr(6, 61, " "); break;
	case 0xa2: mvaddstr(6, 61, " "); break;
	case 0xc1: mvaddstr(8, 19, " "); break;
	case 0xc4: mvaddstr(8, 23, " "); break;
	case 0xbc: mvaddstr(8, 27, " "); break;
	case 0xca: mvaddstr(8, 31, " "); break;
	case 0xb7: mvaddstr(8, 35, " "); break;
	case 0xb8: mvaddstr(8, 39, " "); break;
	case 0xcf: mvaddstr(8, 43, " "); break;
	case 0xc9: mvaddstr(8, 47, " "); break;
	case 0xd8: mvaddstr(8, 51, " "); break;
	case 0xda: mvaddstr(8, 55, " "); break;
	case 0xb9: mvaddstr(8, 59, " "); break;
	case 0xd1: mvaddstr(8, 63, " "); break;
	case 0xa3: mvaddstr(8, 63, " "); break;
	case 0xc2: mvaddstr(10, 21, " "); break;
	case 0xbb: mvaddstr(10, 25, " "); break;
	case 0xbf: mvaddstr(10, 29, " "); break;
	case 0xcb: mvaddstr(10, 33, " "); break;
	case 0xba: mvaddstr(10, 37, " "); break;
	case 0xd0: mvaddstr(10, 41, " "); break;
	case 0xd3: mvaddstr(10, 45, " "); break;
	case 0xc8: mvaddstr(10, 49, " "); break;
	case 0xd9: mvaddstr(10, 53, " "); break;
	case 0xd2: mvaddstr(10, 57, " "); break;
	case 0xdb: mvaddstr(10, 61, " "); break;
	case 0x0a:
		mvaddstr(6, 65, "     ");
		mvaddstr(7, 67, "   ");
		mvaddstr(8, 67, "   ");
		break;
	default:
		mvaddstr(12, 31, "      SPACE          ");
		break;
	}
}

makehands()
{
    mvaddstr(14, 18,     "___");
    mvaddstr(15, 16,   "__| |__");
    mvaddstr(16, 14, "__| | | |");
    mvaddstr(17, 14, "| | | | | __");
    mvaddstr(18, 14, "| | | | | | |");
    mvaddstr(19, 14, "| | | | |_| |");
    mvaddstr(20, 14, "|           |");
    mvaddstr(21, 14, "|_         _|");
    mvaddstr(22, 14, " |_________|");

    mvaddstr(14, 60,       "___");
    mvaddstr(15, 58,     "__| |__");
    mvaddstr(16, 58,     "| | | |__");
    mvaddstr(17, 54, "___ | | | | |");
    mvaddstr(18, 54, "| | | | | | |");
    mvaddstr(19, 54, "| |_| | | | |");
    mvaddstr(20, 54, "|           |");
    mvaddstr(21, 54, "|_         _|");
    mvaddstr(22, 54, " |_________|");
}

handreverse(ch)
int ch;
{
	standout();
	handclear(ch);
	standend();
}

int finger(ch)
int ch;
{
	switch(keyboard) {
        case KEYBOARD_LUNA:
		return luna_finger(ch);
	default:
	case KEYBOARD_NEWS:
	case KEYBOARD_RIOS:
		return news_finger(ch);
	}
}

int luna_finger(ch)
int ch;
{
        int shift;
	int rv;

	shift = FALSE;
        if ('A' <= ch && ch <= 'Z') {
		ch += 'a' - 'A';
		shift = TRUE;
	}
	switch(ch){
	case '!': shift = TRUE;
	case '1':
	case 'q':
	case 'a':
	case 'z':
	case 0xc7:
	case 0xc0:
	case 0xc1:
	case 0xc2:
		rv = LEFT_KO;
		break;
        case '"':
		shift = TRUE;
	case '2':
	case 'w':
	case 's':
	case 'x':
	case 0xcc:
	case 0xc3:
	case 0xc4:
	case 0xbb:
		rv = LEFT_KU;
		break;
	case '#':
		shift = TRUE;
	case '3':
	case 'e':
	case 'd':
	case 'c':
	case 0xb1:
	case 0xb2:
	case 0xbc:
	case 0xbf:
		rv = LEFT_NA;
		break;
	case '$':
	case '%':
		shift = TRUE;
	case '4':
	case '5':
	case 'r':
	case 't':
	case 'f':
	case 'g':
	case 'b':
	case 'v':
	case 0xb3:
	case 0xb4:
	case 0xbd:
	case 0xb6:
	case 0xca:
	case 0xb7:
	case 0xba:
	case 0xcb:
		rv = LEFT_HI;
		break;
	case '&':
	case '\'':
		shift = TRUE;
	case '6':
	case '7':
	case 'y':
	case 'u':
	case 'h':
	case 'j':
	case 'n':
	case 'm':
	case 0xb5:
	case 0xd4:
	case 0xdd:
	case 0xc5:
	case 0xb8:
	case 0xcf:
	case 0xd0:
	case 0xd3:
		rv = RIGHT_HI;
		break;
	case '(':
	case '<':
		shift = TRUE;
	case '8':
	case 'i':
	case 'k':
	case ',':
	case 0xd5:
	case 0xc6:
	case 0xc9:
	case 0xc8:
		rv = RIGHT_NA;
		break;
	case ')':
	case '>':
		shift = TRUE;
	case '9':
	case 'o':
	case 'l':
	case '.':
	case 0xd6:
	case 0xd7:
	case 0xd8:
	case 0xd9:
		rv = RIGHT_KU;
		break;
	case ' ':
		rv = RIGHT_O;
		break;
	case '=':
	case '`':
	case '+':
	case '*':
	case '?':
	case '~':
	case '{':
	case '}':
	case '_':
	case '|':
		shift = TRUE;
	default:
		rv = RIGHT_KO;
		break;
	}
	if (shift) return -rv;
	return rv;
}

int news_finger(ch)
int ch;
{
	int shift;
	int rv;

	shift = FALSE;
        if ('A' <= ch && ch <= 'Z') {
		ch += 'a' - 'A';
		shift = TRUE;
	}
	switch(ch){
	case '!':
		shift = TRUE;
	case '1':
	case 'q':
	case 'a':
	case 'z':
	case 0xc7:
	case 0xc0:
	case 0xc1:
	case 0xc2:
		rv = LEFT_KO;
		break;
	case '@':
		shift = TRUE;
	case '2':
	case 'w':
	case 's':
	case 'x':
	case 0xcc:
	case 0xc3:
	case 0xc4:
	case 0xbb:
		rv = LEFT_KU;
		break;
	case '#':
		shift = TRUE;
	case '3':
	case 'e':
	case 'd':
	case 'c':
	case 0xb1:
	case 0xb2:
	case 0xbc:
	case 0xbf:
		rv = LEFT_NA;
		break;
	case '$':
	case '%':
		shift = TRUE;
	case '4':
	case '5':
	case 'r':
	case 't':
	case 'f':
	case 'g':
	case 'b':
	case 'v':
	case 0xb3:
	case 0xb4:
	case 0xbd:
	case 0xb6:
	case 0xca:
	case 0xb7:
	case 0xba:
	case 0xcb:
		rv = LEFT_HI;
		break;
	case '^':
	case '&':
		shift = TRUE;
	case '6':
	case '7':
	case 'y':
	case 'u':
	case 'h':
	case 'j':
	case 'n':
	case 'm':
	case 0xb5:
	case 0xd4:
	case 0xdd:
	case 0xc5:
	case 0xb8:
	case 0xcf:
	case 0xd0:
	case 0xd3:
		rv = RIGHT_HI;
		break;
	case '*':
	case '<':
		shift = TRUE;
	case '8':
	case 'i':
	case 'k':
	case ',':
	case 0xd5:
	case 0xc6:
	case 0xc9:
	case 0xc8:
		rv = RIGHT_NA;
		break;
	case '(':
	case '>':
		shift = TRUE;
	case '9':
	case 'o':
	case 'l':
	case '.':
	case 0xd6:
	case 0xd7:
	case 0xd8:
	case 0xd9:
		rv = RIGHT_KU;
		break;
	case ' ':
		rv = RIGHT_O;
		break;
	case ')':
	case '_':
	case '+':
	case '|':
	case '{':
	case '}':
	case ':':
	case '"':
	case '~':
	case '?':
		shift = TRUE;
	default:
		rv = RIGHT_KO;
		break;
	}
	if (shift) return -rv;
	return rv;
}


handclear(ch)
int ch;
{
	int f;
	int shift;

	f = finger(ch);
	if (f > 0) shift = FALSE;
	else {
		shift = TRUE;
		f = -f;
	}
	switch(f) {
	case LEFT_KO: mvaddch(17, 15, ' '); break;
	case LEFT_KU: mvaddch(16, 17, ' ') ; break;
	case LEFT_NA: mvaddch(15, 19, ' '); break;
	case LEFT_HI: mvaddch(16, 21, ' '); break;
	case LEFT_O:  mvaddch(18, 25, ' '); break;
	case RIGHT_O: mvaddch(18, 55, ' '); break;
	case RIGHT_HI: mvaddch(16, 59, ' '); break;
	case RIGHT_NA: mvaddch(15, 61, ' '); break;
	case RIGHT_KU: mvaddch(16, 63, ' '); break;
	case RIGHT_KO: mvaddch(17, 65, ' '); break;
	}
	if (shift) {
		if (LEFT_KO <= f && f <= LEFT_O) {
			mvaddch(17, 65, ' ');
		}
		else {
			mvaddch(17, 15, ' ');
		}
	}
}
