/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
ե̾: menu.c
⥸塼 ID : 4.1
⥸塼̾ : menu
ǽ: ͵פΥ˥塼ɥ֥
:  ã ()
*******************************************************************************/
#ifdef	NO_CURSES
#include	<stdio.h>
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#include	"yumihead.h"
#include	<sys/file.h>
#include	<signal.h>
#include	<time.h>

#define SWITCH_IMMEDIATE

int keyboard_on;
int keyboard_reverse;
int hand_on;
int hand_reverse;
int bell_on;
int int_flag;
int timer_cursec;
int timer_timelimit;

char **word_list = NULL;
int word_list_length = 0;

struct level *level_table = NULL;

int max_level = 0;

extern char *getenv();

struct history {
	struct history *next;
	char *filename;
} *history = NULL;

menu_interrupt()
{
	if (int_flag) {
		finish(1);	/* abnormal stop */
	}
	int_flag = TRUE;
}

#ifdef	INCORE_FILE
extern char data[];
extern int data_size;

extern struct index {
	char *key;
	int offset;
	int size;
} menu_index[];

extern int menu_index_max;

struct menu_file {
	int index;
	int pointer;
};

FILE *menu_fopen(fname)
char *fname;
{
	int i, j, k, c;
	struct menu_file *fp;
	int found;

	i = 0;
	j = menu_index_max-1;
	while (i < j) {
		k = (i+j)/2;
		c = strcmp(menu_index[k].key, fname);
		if (c == 0) {
			i = j = k;
		}
		else if (c < 0) i = k + 1;
		else j = k - 1;
	}
	if (i != j || strcmp(menu_index[i].key, fname) != 0) return NULL;
	fp = (struct menu_file *)malloc(sizeof(struct menu_file));
	fp->index = i;
	fp->pointer = 0;
	return (FILE *)fp;
}

menu_fclose(fp)
FILE *fp;
{
	free(fp);
}

char *menu_fgets(fpa, ignore_space)
FILE *fpa;
int ignore_space;
{
	struct menu_file *fp = (struct menu_file *)fpa;
	char buf[512];
	char *p;
	int kanji;
	int ch;
	int start;

	if (fp->pointer >= menu_index[fp->index].size) return NULL;
	start = ignore_space;
	p = buf;
	kanji = FALSE;
	while (fp->pointer < menu_index[fp->index].size) {
		ch = data[menu_index[fp->index].offset+fp->pointer++];
		if (start && ch == ' ') continue;
		start = FALSE;
		if (ch == '\n') break;
		if (ch == 27) {
			kanji = !kanji;
			fp->pointer += 2;
		}
		else if (kanji) {
			*p++ = ch | 0x80;
		}
		else {
			*p++ = ch;
		}
	}
	*p = 0;
	p = (char *)malloc(strlen(buf)+1);
	strcpy(p, buf);
	return p;
}
#else  !INCORE_FILE
FILE *menu_fopen(fname)
char *fname;
{
	char buf[1024];
	char *env;
	FILE *fp;

/*	if (fp = fopen(fname, "r")) return fp; */
	if (*fname != '/') {
		if (env = getenv("YUMIDIR")) {
			strcpy(buf, env);
			strcat(buf, "/");
			strcat(buf, fname);
			if (fp = fopen(buf, "r")) return fp;
		}
#ifdef	DEFAULT_YUMIDIR
		strcpy(buf, DEFAULT_YUMIDIR);
		strcat(buf, "/");
		strcat(buf, fname);
		return fopen(buf, "r");
#else  !DEFAULT_YUMIDIR
#endif	DEFAULT_YUMIDIR
	}
	return NULL;
}

#define menu_fclose(fp)	fclose(fp)

char *menu_fgets(fp, ignore_space)
FILE *fp;
int ignore_space;
{
	char buf[512];
	char *p, *q, *r;
	int kanji;

	if (fgets(buf, sizeof(buf), fp) == NULL) return NULL;
	p = buf + strlen(buf);
	if (p > buf && *(p-1) == '\n') *--p = 0;
	p = buf;
	if (ignore_space) while (*p && *p <= ' ') p++;
	/* conver JIS to UJIS */
	kanji = FALSE;
	q = r = p;
	while (*q) {
		if (*q == 27) {
			kanji = !kanji;
			q += 3;
		}
		else if (kanji) {
			*r++ = *q++ | 0x80;
		}
		else {
			*r++ = *q++;
		}
	}
	*r = 0;
	q = (char *)malloc(strlen(p)+1);
	strcpy(q, p);
	return q;
}
#endif	INCORE_FILE

menu_main(fname)
char *fname;
{
	FILE *fp;
	char *p, *q, *r;
	char *sfname;
	int lines;
	int x, y;
	char buf[80];
	int sel;
	int repeat_counter;
	int length_counter;
	int time_limit;
	int start_time;
	int finish_time;
	int need_return;
	struct T_TOUCH TOUCH;
	int ch;
#ifdef	BSD
	struct sigvec vec, ovec;
#endif	BSD
	struct history *h;
	char *title;
	int level;
	int from, to;
	int handy;

#ifdef	BSD
	vec.sv_handler = menu_interrupt;
	vec.sv_mask = 0;
	vec.sv_flags = SV_INTERRUPT;
	sigvec(SIGINT, &vec, &ovec);
#endif	BSD
#ifdef	SYSV
	signal(SIGINT, menu_interrupt);
#endif	SYSV

	int_flag = FALSE;
	title = NULL;
	lines = 0;
	repeat_counter = 30;
	length_counter = 10;
	time_limit = 60;
	srandom(time(0));
	if ((fp = menu_fopen(fname)) == NULL) {
		fprintf(stderr, "cannot open menu file: %s\r\n", fname);
		finish(1);
	}
	h = (struct history *)malloc(sizeof(struct history));
	h->next = history;
	h->filename = fname;
	history = h;
	menu_load_level();
	while ((p = menu_fgets(fp, TRUE)) != NULL) {
		lines++;
		if (*p == ';') {
			/* comment */
		}
		else if (strcmp(p, "needreturn") == 0) {
			need_return = TRUE;
		}
		else if (strcmp(p, "clear") == 0) {
			clear();
			keyboard_on = FALSE;
			hand_on = FALSE;
			bell_on = FALSE;
			need_return = FALSE;
		}
		else if (strcmp(p, "exit") == 0) {
			return;
		}
		else if (strcmp(p, "keyboard display") == 0) {
			makekeyboard();
			keyboard_on = TRUE;
			keyboard_reverse = TRUE;
		}
		else if (strcmp(p, "keyboard reverse") == 0) {
			keyboard_reverse = TRUE;
		}
		else if (strcmp(p, "keyboard no reverse") == 0) {
			keyboard_reverse = FALSE;
		}
		else if (strcmp(p, "hand display") == 0) {
			makehands();
			hand_on = TRUE;
			hand_reverse = TRUE;
		}
		else if (strcmp(p, "hand reverse") == 0) {
			hand_reverse = TRUE;
		}
		else if (strcmp(p, "hand no reverse") == 0) {
			hand_reverse = FALSE;
		}
		else if (strcmp(p, "levelcheck") == 0) {
			menu_level_check(level);
		}
		else if (strncmp(p, "level", 5) == 0) {
			level = 0;
			sscanf(p+5, "%d", &level);
		}
		else if (strncmp(p, "showscore", 9) == 0) {
			from = 0;
			to = max_level-1;
			sscanf(p+9, "%d %d", &from, &to);
			menu_show_score(from, to);
		}
		else if (strncmp(p, "repeat", 6) == 0) {
			sscanf(p+6, "%d", &repeat_counter);
		}
		else if (strncmp(p, "length", 6) == 0) {
			sscanf(p+6, "%d", &length_counter);
		}
		else if (strncmp(p, "timelimit", 9) == 0) {
			sscanf(p+9, "%d", &time_limit);
		}
		else if (strncmp(p, "title", 5) == 0) {
			for (q = p+5; *q && (*q == ' '); q++);
			if (title) free(title);
			title = (char *)malloc(strlen(q)+1);
			strcpy(title, q);
		}
		else if (strcmp(p, "text") == 0) {
			menu_text(fp, title, time_limit, need_return, &TOUCH);
		}
		else if (strcmp(p, "kanatext") == 0) {
			menu_kanatext(fp, title, time_limit, &TOUCH);
		}
		else if (strncmp(p, "randomchar", 10) == 0) {
			if (*(p+10) == 0) {
				menu_random_char("", repeat_counter, &TOUCH);
			}
			else {
				menu_random_char(p+11, repeat_counter, &TOUCH);
			}
		}
		else if (strcmp(p, "randomword") == 0) {
			menu_random_word(length_counter, repeat_counter, &TOUCH);
		}
		else if (strncmp(p, "randomstring", 12) == 0) {
			if (*(p+12) == 0) {
				menu_random_string("", length_counter, repeat_counter, &TOUCH);
			}
			else {
				menu_random_string(p+13, length_counter, repeat_counter, &TOUCH);
			}
		}
		else if (strncmp(p, "wordfile", 8) == 0) {
			for (q = p+8; *q && (*q <= ' '); q++);
			menu_word_file(q);
		}
		else if (strcmp(p, "confirm") == 0) {
			int_flag = FALSE;
			mvaddstr(LINES-1, 0, "꥿󥭡ϤƤ");
			refresh();
			while ((ch = getch()) != '\n' && ch != '\r' && ch != EOF && !int_flag);
		}
		else if (strcmp(p, "bell") == 0) {
			bell_on = TRUE;
		}
		else if (strcmp(p, "start") == 0) {
			start_time = time(0);
			bzero((char *)&TOUCH, sizeof(TOUCH));
		}
		else if (strncmp(p, "finish", 6) == 0) {
			handy = 0;
			sscanf(p+6, "%d", &handy);
			finish_time = time(0);
			logtrain(start_time, finish_time,
				 TOUCH.NOTOH, TOUCH.NOMTOH, TOUCH.MISS,
				 title, level, handy);
		}
		else if (strncmp(p, "show", 4) == 0) {
			if (sscanf(p+4, "%d%d", &x, &y) == 2) {
				menu_show(x, y, fp);
			}
			else {
				menu_show(curx, cury, fp);
			}
		}
		else if (strncmp(p, "writeln", 7) == 0) {
			addstr(p+7);
			addstr("\n");
		}
		else if (strncmp(p, "write", 5) == 0) {
			addstr(p+5);
		}
		else if (strcmp(p, "up") == 0) {
			if (history->next == NULL) finish(0);
			h = history;
			history = history->next;
			free(h->filename);
			free(h);
			menu_fclose(fp);
			if ((fp = menu_fopen(history->filename)) == NULL) finish(1);
			lines = 0;
		}
		else if (strncmp(p, "file", 4) == 0) {
			for (q = p+4; *q && *q <= ' '; q++);
			menu_fclose(fp);
			if ((fp = menu_fopen(q)) == NULL) {
				fprintf(stderr, "cannot open menu file: %s\r\n", q);
				finish(1);
			}
			sfname = (char *)malloc(strlen(q)+1);
			strcpy(sfname, q);
			lines = 0;
			int_flag = FALSE;
			h = (struct history *)malloc(sizeof(struct history));
			h->next = history;
			h->filename = sfname;
			history = h;
		}
		else if (strcmp(p, "move last") == 0) {
			move(LINES-1, 0);
		}
		else if (strncmp(p, "move", 4) == 0) {
			sscanf(p+4, "%d%d", &x, &y);
			move(y, x);
		}
		else if (strncmp(p, "switch", 6) == 0) {
			x = curx;
			y = cury;
			for (;;) {
				int_flag = FALSE;
				refresh();
#ifdef	SWITCH_IMMEDIATE
				while (((ch = getch()) < '1' || ch > '9') && (ch != 'q' && ch != 'r' && ch != 'u') && !int_flag);
				if (int_flag) break;
				addch(ch);
				refresh();
				if (ch == 'q') finish(1);
				else if (ch == 'r') {
					while (history->next) {
						h = history;
						history = history->next;
						free(h->filename);
						free(h);
					}
					menu_fclose(fp);
					if ((fp = menu_fopen(history->filename)) == NULL) finish(1);
					int_flag = FALSE;
					lines = 0;
					break;
				}
				else if (ch == 'u') {
					if (history->next) {
						h = history;
						history = history->next;
						free(h->filename);
						free(h);
					}
					menu_fclose(fp);
					if ((fp = menu_fopen(history->filename)) == NULL) finish(1);
					int_flag = FALSE;
					lines = 0;
					break;
				}
				sel = ch - '0';
#else  !SWITCH_IMMEDIATE
				sfc_getstr(buf, sizeof(buf));
				if (int_flag) break;
				sel = 0;
				sscanf(buf, "%d", &sel);
#endif	SWITCH_IMMEDIATE
				q = p+6;
				while (*q && *q == ' ') q++;
				while (*q && sel != 1) {
					while (*q && *q != ' ') q++;
					while (*q && *q == ' ') q++;
					sel --;
				}
				if (*q) {
					r = q;
					while (*r && *r != ' ') r++;
					*r = 0;
					menu_fclose(fp);
					if (strcmp(q, "up") == 0) {
						if (history->next == NULL) finish(0);
						h = history;
						history = history->next;
						free(h->filename);
						free(h);
						if ((fp = menu_fopen(history->filename)) == NULL) finish(1);
					}
					else {
						if ((fp = menu_fopen(q)) == NULL) {
							fprintf(stderr, "cannot open menu file: %s\r\n", q);
							finish(1);
						}
						sfname = (char *)malloc(strlen(q)+1);
						strcpy(sfname, q);
						h = (struct history *)malloc(sizeof(struct history));
						h->next = history;
						h->filename = sfname;
						history = h;
					}
					int_flag = FALSE;
					lines = 0;
					break;
				}
				else {
					standout();
					mvaddstr(y+1, x, "ֹ椬ְäƤޤ.");
					standend();
					move(y, x);
				}
			}
		}
		else {
			fprintf(stderr, "unknown command line: %s\r\n", p);
			fprintf(stderr, "file \"%s\" line %d\r\n", history->filename, lines);
		}
		free(p);
		if (int_flag) {
			if (history->next == NULL) finish(0);
			h = history;
			history = history->next;
			free(h->filename);
			free(h);
			menu_fclose(fp);
			if ((fp = menu_fopen(history->filename)) == NULL) finish(1);
			int_flag = FALSE;
			lines = 0;
		}
		refresh();
	}
}

menu_random_char(p, n, TOUCH)
char *p;
int n;
struct T_TOUCH *TOUCH;
{
	int p_len;
	int ch, och, c;
	int err;

	if (int_flag) return;
	p_len = strlen(p);
	och = 0;
	while (n-- > 0) {
		if (p_len > 0) {
			do {
				ch = *(p + (random() % p_len));
			} while (ch == och && p_len > 3);
			och = ch;
		}
		else {
			ch = random()%(127-' ') + ' ';
		}
		err = 0;
		if (hand_on && hand_reverse) handreverse(ch);
		if (keyboard_on && keyboard_reverse)keyreverse(ch);
		for (;;) {
			if (err) standout();
			mvprintw(1, 35, "\" %c \"", ch);
			if (err) standend();
			move(2, 37);
			refresh();
			/* user input */
			if ((c = getch()) == EOF || int_flag) {
				return;
			}
			/* hantei */
			if (ch == c) {
				if (hand_on && hand_reverse) handclear(ch);
				if (keyboard_on && keyboard_reverse) keyclear(ch);
				refresh();
				TOUCH->NOTOH++;
				break;
			} else {
				err = TRUE;
				if (bell_on) flash();
				TOUCH->NOTOH++;
				TOUCH->NOMTOH++;
				TOUCH->MISS[ch]++;
			}
		}
	}
}

menu_random_string(p, len, n, TOUCH)
char *p;
int len, n;
struct T_TOUCH *TOUCH;
{
	char *buf;
	int i, p_len;
	int c;

	if (int_flag) return;
	buf = (char *)malloc(len+1);
	p_len = strlen(p);
	while (n-- > 0) {
		for (i = 0; i < len; i++) {
			if (p_len > 0) {
				buf[i] = *(p + (random()%p_len));
			}
			else {
				buf[i] = random()%(127-' ') + ' ';
			}
		}
		buf[len] = 0;
		mvaddch(1, 24, '\n');
		mvprintw(1, 24, "\"%s\"", buf);
		mvaddch(2, 25, '\n');
		move(2, 25);
		refresh();
		for (i = 0; i < len;) {
			if (hand_on && hand_reverse) handreverse(buf[i]);
			if (keyboard_on && keyboard_reverse) keyreverse(buf[i]);
			move(2, i + 25);
			if ((c = getch()) == EOF || int_flag) {
				free(buf);
				return;
			}
			if (c == buf[i]) {
				mvaddch(2, i + 25, c);
				refresh();
				if (hand_on && hand_reverse) handclear(buf[i]);
				if (keyboard_on && keyboard_reverse) keyclear(buf[i]);
				TOUCH->NOTOH++;
				i++;
			}
			else{
				if (bell_on) flash();
				TOUCH->NOTOH++;		
				TOUCH->NOMTOH++;		
				TOUCH->MISS[buf[i]]++;
			}
		}
	}
	free(buf);
}

menu_show(x, y, fp)
int x, y;
FILE *fp;
{
	char *p, *q;
	int mx, my;
	int kanji;

	mx = my = -1;
	while ((p = menu_fgets(fp, FALSE)) != NULL) {
		if (strcmp(p, "showend") == 0) {
			free(p);
			break;
		}
		move(y, x);
		kanji = FALSE;
		for (q = p; *q; q++) {
			if (*q == 27) {
				kanji = !kanji;
			}
			if (!kanji && *q == '@') {
				my = cury;
				mx = curx;
				addch(' ');
			}
			else addch(*q);
		}
		y++;
		free(p);
	}
	if (mx >= 0 && my >= 0) move(my, mx);
}

menu_word_file(filename)
char *filename;
{
	FILE *fp;
	char *p, **ps, **new_ps;
	int i, j, len, new_len;

	if ((fp = menu_fopen(filename)) == NULL) {
		fprintf(stderr, "cannot open word file \"%s\"\n", filename);
		return;
	}
	i = len = 0;
	while (p = menu_fgets(fp, TRUE)) {
		if (i >= len) {
			new_len = len + 128;
			new_ps = (char **)malloc(sizeof(char *)*new_len);
			if (len > 0) {
				for (j = 0; j < i; j++) {
					new_ps[j] = ps[j];
				}
				free(ps);
			}
			len = new_len;
			ps = new_ps;
		}
		ps[i] = p;
		i++;
	}
	menu_fclose(fp);
	word_list = ps;
	word_list_length = i;
}

menu_random_word(len, n, TOUCH)
int len, n;
struct T_TOUCH *TOUCH;
{
	char *buf, *p;
	int i, k, j, p_len;
	int c;
	int *done, found;

	if (int_flag || word_list_length < n) return;
	done = (int *)malloc(sizeof(int)*n);
	for (k = 0; k < n; k++) {
		found = FALSE;
		while (!found) {
			j = random() % word_list_length;
			found = TRUE;
			for (i = 0; i < k; i++) {
				if (done[i] == j) {
					found = FALSE;
					break;
				}
			}
		}
		p = word_list[j];
		done[k] = j;
		p_len = strlen(p)+1;
		c = (len + p_len - 1) / p_len;
		buf = (char *)malloc(p_len * c - 1);
		*buf = 0;
		for (i = 0; i < c; i++) {
			strcat(buf, p);
			if (i < c - 1) strcat(buf, " ");
		}
		p_len = strlen(buf);
		mvaddch(1, 24, '\n');
		mvprintw(1, 24, "\"%s\"", buf);
		mvaddch(2, 25, '\n');
		move(2, 25);
		refresh();
		for (i = 0; i < p_len;) {
			if (hand_on && hand_reverse) handreverse(buf[i]);
			if (keyboard_on && keyboard_reverse) keyreverse(buf[i]);
			move(2, i + 25);
			if ((c = getch()) == EOF || int_flag) {
				free(buf);
				return;
			}
			if (c == buf[i]) {
				mvaddch(2, i + 25, c);
				refresh();
				if (hand_on && hand_reverse) handclear(buf[i]);
				if (keyboard_on && keyboard_reverse) keyclear(buf[i]);
				TOUCH->NOTOH++;
				i++;
			}
			else{
				if (bell_on) flash();
				TOUCH->NOTOH++;		
				TOUCH->NOMTOH++;		
				TOUCH->MISS[buf[i]]++;
			}
		}
		free(buf);
	}
	free(done);
}

menu_text_timer()
{
	int	y, x;

	getyx(stdscr, y, x);

	/* cursor save and write time and cursor unsave */
	mvprintw(LINES-1, 49, "в: %2d ʬ %2d ", timer_cursec/60, timer_cursec%60);

	if(timer_timelimit == timer_cursec) {
		flash();
		flash();
		flash();
		flash();
		flash();
		standout();
		mvaddstr(LINES-1, 8, "»ĶǤ.");
		standend();
		refresh();
		flash();
		flash();
		flash();
		flash();
		flash();
	}
	move(y, x);
	refresh();

	signal(SIGALRM, menu_text_timer);
	alarm(1);
	timer_cursec++;
}


#define MAX_LINES	128
#define SHOW_LINES	9

menu_text(fp, title, timelimit, need_return, TOUCH)
FILE *fp;
char *title;
int timelimit;
int need_return;
struct T_TOUCH *TOUCH;
{
	int lines, cols;
	char *p, *q;
	char *line[MAX_LINES];
	char *user_line[MAX_LINES];
	int i, j;
	int ch, c;
	int tab;
	int scroll;

	mvaddstr(0, (COLS-strlen(title))/2, title);
	lines = 0;
	while (p = menu_fgets(fp, FALSE)) {
		if (strcmp(p, "textend") == 0) {
			free(p);
			break;
		}
		if (lines < MAX_LINES) {
			if (lines < SHOW_LINES) mvaddstr(2 + 2 * lines, 8, p);
			line[lines] = p;
			user_line[lines] = (char *)malloc(strlen(p)+2);
			user_line[lines][0] = 0;
			lines++;
		}
		else free(p);
	}
	mvprintw(1, 49, "»: %2d ʬ %2d ", timelimit/60, timelimit%60);
	refresh();

	timer_cursec = 0;
	timer_timelimit = timelimit;
	menu_text_timer();

	i = 0;
	scroll = 0;
	while (i < lines) {
		if (i - scroll >= SHOW_LINES) {
			scroll += SHOW_LINES/2;
			for (j = 0; j < SHOW_LINES; j++) {
				if (scroll + j < lines) {
					mvaddstr(2 + 2 * j, 8, line[scroll+j]);
					clrtoeol();
					move(3 + 2 * j, 8);
					p = user_line[scroll+j];
					attrset(A_UNDERLINE);
					while (*p) {
						if (*p & 0x80) {
							standout();
							addch(*p & 0x7f);
							standend();
						}
						else addch(*p);
						p++;
					}
					attrset(0);
					clrtoeol();
				}
				else {
					move(2 + 2 * j, 8);
					clrtoeol();
					move(3 + 2 * j, 8);
					clrtoeol();
				}
			}
		}
		cols = strlen(line[i])+1;
		j = 0;
		tab = 0;
		while (j < cols) {
			move(3 + 2 * (i - scroll), 8 + j);
			refresh();
			c = line[i][j];
			if (tab > 0) {
				ch = ' ';
				tab--;
			}
			else {
				ch = getch();
				if (int_flag) break;
			}
			if (ch == '\t') {
				tab = ((j+7)/8*8+8)-j;
				TOUCH->NOTOH -= tab-1;
			}
			else if (ch == 0x08 || ch == 0x7f) {
				if (j > 0) j--;
				else {
					if (i > scroll) {
						i--;
						j = strlen(line[i]);
						cols = j + 1;
					}
				}
				mvaddch(3 + 2 * (i - scroll), 8 + j, ' ');
				user_line[i][j] = 0;
			}
			else if (ch < 0x20 && ch != '\n' && ch != '\r') {
				if (bell_on) flash();
			}
			else if (c == 0 && need_return) {
				if (ch == '\n' || ch == '\r') {
					j++;
					user_line[i][j] = 0;
				}
				else {
					if (bell_on) flash();
				}
			}
			else if ((c == 0 && (ch == '\n' || ch == '\r' || ch == ' ')) || c == ch) {
				attrset(A_UNDERLINE);
				if (c == 0) addch(' ');
				else addch(c);
				attrset(0);
				TOUCH->NOTOH++;
				user_line[i][j] = c;
				j++;
				user_line[i][j] = 0;
			}
			else {
				if (bell_on) flash();
				standout();
				if (!(' '<= ch && ch < 0x7f)) ch = ' ';
				addch(ch);
				standend();
				TOUCH->NOTOH++;
				TOUCH->NOMTOH++;
				TOUCH->MISS[line[i][j]]++;
				user_line[i][j] = ch | 0x80;
				j++;
				user_line[i][j] = 0;
			}
		}
		if (int_flag) break;
		i++;
	}
	alarm(0);
	for (i = 0; i < lines; i++) free(line[i]);
}

menu_kanatext(fp, title, timelimit, TOUCH)
FILE *fp;
char *title;
int timelimit;
struct T_TOUCH *TOUCH;
{
	int lines, cols;
	char *p, *q;
	char *line[MAX_LINES];
	int i, j, k;
	int ch, c;
	int tab;
	char romaji[10];
	char kana[10];
	int romaji_len;
	int kana_len;

	mvaddstr(0, (COLS-strlen(title))/2, title);
	lines = 0;
	while (p = menu_fgets(fp, FALSE)) {
		if (strcmp(p, "textend") == 0) {
			free(p);
			break;
		}
		if (lines < SHOW_LINES) {
			mvaddstr(2 + 2 * lines, 8, p);
			line[lines] = p;
			lines++;
		}
		else free(p);
	}
	mvprintw(1, 49, "»: %2d ʬ %2d ", timelimit/60, timelimit%60);
	refresh();

	timer_cursec = 0;
	timer_timelimit = timelimit;
	menu_text_timer();

	i = 0;
	romaji_len = 0;
	while (i < lines) {
		if (romaji_len > 0) {
			move(3 + 2 * (i-1), 8 + j);
			clrtoeol();
			move(3 + 2 * i, 8);
			for (k = 0; k < romaji_len; k++) addch(romaji[k]);
		}
		cols = strlen(line[i])+1;
		j = 0;
		tab = 0;
		while (j < cols) {
			move(3 + 2 * i, 8 + j + romaji_len);
			refresh();
			c = line[i][j];
			if (c == 0) break;
			if (tab > 0) {
				ch = ' ';
				tab--;
			}
			else {
				ch = getch();
				if (int_flag) break;
			}
			if (ch == '\t') {
				tab = ((j+7)/8*8+8)-j;
				TOUCH->NOTOH -= tab-1;
			}
			else if (ch == 0x08 || ch == 0x7f) {
				if (romaji_len > 0) {
					romaji_len--;
				}
				else if (j > 0) {
					j--;
					if (j > 0 && line[i][j] & 0x80) j--;
				}
				else {
					if (i > 0) {
						i--;
						j = strlen(line[i])-1;
						if (j > 0 && line[i][j] & 0x80) j--;
						cols = j+1;
					}
				}
				move(3 + 2 * i, 8 + j + romaji_len);
				clrtoeol();
			}
			else if (ch < 0x20 && ch != '\n' && ch != '\r') {
				if (bell_on) flash();
			}
			else {
				romaji[romaji_len] = 0;
				romkana(romaji, ch, kana);
				kana_len = strlen(kana);
				romaji_len = strlen(romaji);
				move(3+2*i, 8+j);
				for (k = 0; k < kana_len; k++) {
					if (kana[k] & 0x80) {
						if (line[i][j+k] == kana[k] && line[i][j+k+1] == kana[k+1]) {
							attrset(A_UNDERLINE);
							addch(kana[k]);
							addch(kana[k+1]);
							attrset(0);
						}
						else {
							if (bell_on) flash();
							standout();
							addch(kana[k]);
							addch(kana[k+1]);
							standend();
							TOUCH->NOMTOH += 2;
						}
						k++;
					}
					else {
						if (line[i][j+k] == kana[k] ||
						    line[i][j+k] == 0 && (kana[k] == '\n' || kana[k] == '\r' || kana[k] == ' ')) {
							attrset(A_UNDERLINE);
							addch(kana[k]>=' '?kana[k]:' ');
							attrset(0);
						}
						else {
							if (bell_on) flash();
							standout();
							addch(kana[k]>=' '?kana[k]:' ');
							standend();
							TOUCH->NOMTOH++;
						}
					}
				}
				for (k = 0; k < kana_len; k++) {
					if (line[i][j] & 0x80) {
						j += 2;
						k++;
						TOUCH->NOTOH++;
					}
					else j++;
					TOUCH->NOTOH++;
				}
				for (k = 0; k < romaji_len; k++) {
					addch(romaji[k]);
				}
				clrtoeol();
			}
		}
		if (int_flag) break;
		i++;
	}
	alarm(0);
	for (i = 0; i < lines; i++) free(line[i]);
}

romkana(rom, ch, kana)
char rom[], kana[];
int ch;
{
	int wait;
	int error;
	int rom_len, henkan_len;
	int i;

	rom_len = strlen(rom);
	rom[rom_len++] = ch;
	rom[rom_len] = 0;
	wait = FALSE;
	error = FALSE;
	henkan_len = 1;
	switch (rom[0]) {
	      case 'a': strcpy(kana, ""); break;
	      case 'i': strcpy(kana, ""); break;
	      case 'u': strcpy(kana, ""); break;
	      case 'e': strcpy(kana, ""); break;
	      case 'o': strcpy(kana, ""); break;
	      case 'k':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'k': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 'w':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'i': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE;
		      default: error = TRUE; break;
		}
		break;
	      case 's':
		henkan_len = 2;
		switch (rom[1]) {
		      case 's': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 'h':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'i': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 't':
		henkan_len = 2;
		switch (rom[1]) {
		      case 't': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 's':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "Ĥ"); break;
			      case 'i': strcpy(kana, "Ĥ"); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, "Ĥ"); break;
			      case 'o': strcpy(kana, "Ĥ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'c':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'h':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'i': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'n':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "ˤ"); break;
			      case 'u': strcpy(kana, "ˤ"); break;
			      case 'e': strcpy(kana, "ˤ"); break;
			      case 'o': strcpy(kana, "ˤ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case '\'':
		      case 'n': strcpy(kana, ""); break;
		      case 0: wait = TRUE; break;
		      default:
			henkan_len = 1;
			strcpy(kana, "");
			break;
		}
		break;
	      case 'h':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'h': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "Ҥ"); break;
			      case 'u': strcpy(kana, "Ҥ"); break;
			      case 'e': strcpy(kana, "Ҥ"); break;
			      case 'o': strcpy(kana, "Ҥ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'f':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'f': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, "դ"); break;
		      case 'i': strcpy(kana, "դ"); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, "դ"); break;
		      case 'o': strcpy(kana, "դ"); break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'm':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'm': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "ߤ"); break;
			      case 'u': strcpy(kana, "ߤ"); break;
			      case 'e': strcpy(kana, "ߤ"); break;
			      case 'o': strcpy(kana, "ߤ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'y':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'y': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'r':
	      case 'l':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'r':
		      case 'l': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, "ꤧ"); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'w':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'w': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'g':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'g': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 'w':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'i': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'z':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'z': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'e': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case '.': strcpy(kana, ""); break;
		      case '-': strcpy(kana, ""); break;
		      case '[': strcpy(kana, ""); break;
		      case ']': strcpy(kana, ""); break;
		      case 'r': strcpy(kana, ""); break;
		      case 'c': strcpy(kana, ""); break;
		      case 'p': strcpy(kana, ""); break;
		      case '/': strcpy(kana, ""); break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'j':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'j': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'd':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'd': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "¤"); break;
			      case 'u': strcpy(kana, "¤"); break;
			      case 'e': strcpy(kana, "¤"); break;
			      case 'o': strcpy(kana, "¤"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'b':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'b': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "Ӥ"); break;
			      case 'u': strcpy(kana, "Ӥ"); break;
			      case 'e': strcpy(kana, "Ӥ"); break;
			      case 'o': strcpy(kana, "Ӥ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'p':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'p': strcpy(kana, ""); henkan_len = 1; break;
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, "Ԥ"); break;
			      case 'u': strcpy(kana, "Ԥ"); break;
			      case 'e': strcpy(kana, "Ԥ"); break;
			      case 'o': strcpy(kana, "Ԥ"); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case 'x':
		henkan_len = 2;
		switch (rom[1]) {
		      case 'a': strcpy(kana, ""); break;
		      case 'i': strcpy(kana, ""); break;
		      case 'u': strcpy(kana, ""); break;
		      case 'e': strcpy(kana, ""); break;
		      case 'o': strcpy(kana, ""); break;
		      case 't':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'u': strcpy(kana, ""); break;
			      case 's':
				henkan_len = 4;
				switch (rom[3]) {
				      case 'u': strcpy(kana, ""); break;
				      case 0: wait = TRUE; break;
				      default: error = TRUE; break;
				}
				break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
			break;
		      case 'y':
			henkan_len = 3;
			switch (rom[2]) {
			      case 'a': strcpy(kana, ""); break;
			      case 'u': strcpy(kana, ""); break;
			      case 'o': strcpy(kana, ""); break;
			      case 0: wait = TRUE; break;
			      default: error = TRUE; break;
			}
		      case 0: wait = TRUE; break;
		      default: error = TRUE; break;
		}
		break;
	      case '/': strcpy(kana, ""); break;
	      case '[': strcpy(kana, ""); break;
	      case ']': strcpy(kana, ""); break;
	      case ',': strcpy(kana, ""); break;
	      case '.': strcpy(kana, ""); break;
	      case '-': strcpy(kana, ""); break;
	      default: error = TRUE; break;
	}
	if (wait) {
		kana[0] = 0;
	}
	else if (error) {
		strcpy(kana, rom);
		rom[0] = 0;
	}
	else {
		for (i = 0; i < rom_len - henkan_len; i++) {
			rom[i] = rom[i+henkan_len];
		}
		rom[i] = 0;
	}
}

menu_expand_level(level)
int level;
{
	int i;
	struct level *new_level_table;
	int new_max_level;

	if (level < max_level) return;
	new_max_level = level + 10;
	new_level_table = (struct level *)malloc(sizeof(struct level)*new_max_level);
	for (i = 0; i < new_max_level; i++) {
		if (i < max_level) {
			new_level_table[i].point = level_table[i].point;
			new_level_table[i].date = level_table[i].date;
			new_level_table[i].title = level_table[i].title;
		}
		else {
			new_level_table[i].point = -1;
			new_level_table[i].date = 0;
			new_level_table[i].title = NULL;
		}
	}
	if (level_table) free(level_table);
	level_table = new_level_table;
	max_level = new_max_level;
}

menu_load_level()
{
	char buf[512];
	FILE *fp;
	int i;
	char *q, *r;
	int level, point, date;

	strcpy(buf, getenv("HOME"));
	strcat(buf, "/.yumiko");
	if (fp = fopen(buf, "r")) {
		while (fgets(buf, sizeof(buf), fp) != NULL) {
			if (sscanf(buf, "%d %d %d", &level, &point, &date) == 3 && level >= 0) {
				q = buf+strlen(buf);
				if (*(q-1) == '\n') *(q-1) = NULL;
				q = buf;
				for (i = 0; i < 3; i++) {
					while (*q && *q != ' ') q++;
					if (*q == ' ') q++;
				}
				r = q;
				while (*q) {
					if (*q == '_') *q = ' ';
					q++;
				}
				menu_expand_level(level);
				level_table[level].point = point;
				level_table[level].date = date;
				level_table[level].title = (char *)malloc(strlen(r)+1);
				strcpy(level_table[level].title, r);
			}
		}
		fclose(fp);
	}
}

menu_store_level()
{
	char buf[512];
	int i;
	FILE *fp;
	char *p;

	if (level_table == NULL) return;
	strcpy(buf, getenv("HOME"));
	strcat(buf, "/.yumiko");
	if (fp = fopen(buf, "w")) {
		for (i = 0; i < max_level; i++) {
			if (level_table[i].point >= 0) {
				fprintf(fp, "%d %d %d ", i, level_table[i].point, level_table[i].date);
				p = level_table[i].title;
				while (*p) {
					if (*p == ' ') putc('_', fp);
					else putc(*p, fp);
					p++;
				}
				putc('\n', fp);
			}
		}
		fclose(fp);
	}
}

menu_show_score(from, to)
int from, to;
{
	int i, c;
	struct tm *t;
	int ch;
	int need_wait;

	need_wait = FALSE;
	if (from < 0) from = 0;
	if (to >= max_level) to = max_level-1;
	for (c = 0, i = from; i <= to; i++) {
		if (level_table[i].point >= 0) {
			if (c == 0) {
				clear();
				mvaddstr(0, 35, "    ɽ");
			}
			mvaddstr(c+2, 5, level_table[i].title);
			t = localtime(&level_table[i].date);
			mvprintw(c+2, 38, "  %2dǯ%2d%2d %2d%2dʬ  ", t->tm_year, t->tm_mon+1, t->tm_mday, t->tm_hour, t->tm_min);
			if (level_table[i].point > 100) {
				printw("100+%2d ", level_table[i].point-100);
			}
			else {
				printw("%3d      ", level_table[i].point);
			}
			if (level_table[i].point > 100) addstr("(ͥ+)");
			else if (level_table[i].point >= 90) addstr("(ͥ)");
			else if (level_table[i].point >= 80) addstr("()");
			else if (level_table[i].point >= 60) addstr("()");
			else addstr("(Բ)");
			c++;
			need_wait = TRUE;
		}
		if (need_wait && (c > LINES-5 || i == to)) {
			int_flag = FALSE;
			mvaddstr(LINES-1, 0, "꥿󥭡ϤƤ");
			refresh();
			while ((ch = getch()) != '\n' && ch != '\r' && ch != EOF && !int_flag);
			if (int_flag) break;
			c = 0;
			need_wait = FALSE;
		}
	}
}

menu_level_check(level)
int level;
{
	int i;
	int a;

	if (level_table == NULL) return;
	for (i = 0; i < level; i++) {
		if (level_table[i].point < 60) break;
	}
	if (i < level) {
		clear();
		standout();
		mvaddstr(11, 4, "ƥå");
		a = FALSE;
		for (i = 0; i < level; i++) {
			if (level_table[i].point < 60) {
				if (a) addstr(",");
				printw("%d", i+1);
				a = TRUE;
			}
		}
		addstr("ޤޥƤޤ");
		standend();
		refresh();
		sleep(3);
	}
}
