/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
ե̾: yumimain.c
⥸塼 ID : 0.0
⥸塼̾ : main
ǽ: ͵ץᥤ
: ʡϺ
: Ľɧã
*******************************************************************************/
#ifdef	NO_CURSES
#include	<sys/ioctl.h>
#include	<stdio.h>
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#ifdef	PCAT
#include	<sys/termios.h>
#endif	PCAT
#include	"yumihead.h"

int keyboard = KEYBOARD;

#define KANJI_JIS	1
#define KANJI_UJIS	2
#define KANJI_SJIS	3
int kanji_code = KANJI_JIS;

char *program;

int int_flag = FALSE;

void main (argc,argv)
int	argc;
char	*argv[];
{
	extern void interrupt();
	char *menu;

	program = argv[0];
	argc--;
	argv++;
	menu = "root";
	while (argc > 0) {
		if (strcmp(argv[0], "luna") == 0) {
			keyboard = KEYBOARD_LUNA;
		}
		else if (strcmp(argv[0], "news") == 0) {
			keyboard = KEYBOARD_NEWS;
		}
		else if (strcmp(argv[0], "jis") == 0) {
			kanji_code = KANJI_JIS;
		}
		else if (strcmp(argv[0], "ujis") == 0) {
			kanji_code = KANJI_UJIS;
		}
		else if (strcmp(argv[0], "sjis") == 0) {
			kanji_code = KANJI_SJIS;
		}
		else {
			menu = argv[0];
		}
		argc--;
		argv++;
	}

	/* initialize curses */
	if (init_term() != OK) {
		fputs("Sorry, I can't run on your terminal.\r\n", stderr);
		finish(1);
	}

	menu_main(menu);
	finish(0);
}

int init_term()
{
	char	*getenv();
	char	*p;

	if (initscr() == ERR) {
		fputs("Terminal is too dumb.\r\n", stderr);
		return (ERR);
	}
	raw();
	nonl();
	noecho();
	if (LINES < 24 || COLS < 80) {
		fputs("Terminal size has to be larger than 80 columns x 24 lines.\r\n", stderr);
		return (ERR);
	}
	else
		return (OK);
}


finish(ret)
int	ret;
{
	move(LINES - 1, 0);
	refresh();
	nl();
	echo();
	noraw();
	endwin();
	exit(ret);
}

#ifdef	NO_CURSES
sfc_getstr(buf, max)
char buf[];
int max;
{
	int cx, cy;
	int c, ch;

	cx = curx;
	cy = cury;
	c = 0;
	refresh();
	while ((ch = getch()) != EOF) {
		switch (ch) {
		      case '\n':
		      case '\r':
			buf[c] = 0;
			return;
		      case 'U'-'@':
			if (c > 0) {
				cx -= c;
				c = 0;
				move(cy,cx);
				clrtoeol();
			}
			break;
		      case 'H'-'@':
		      case 0x7f:
			if (c > 0) {
				c--;
				cx--;
				move(cy,cx);
				clrtoeol();
			}
			break;
		      default:
			if (ch >= ' ' && c < max-1) {
				buf[c++] = ch;
				addch(ch);
				cx++;
				move(cy,cx);
			}
			break;
		}
		refresh();
	}
	buf[c] = 0;
	return;
}

/* SFC version curses(?) emulation routines */

#ifdef	PCAT
struct	termios savets, ts;
#else  !PCAT
struct	sgttyb	savemode;
struct	ltchars	savelt;
struct  tchars savetc;
int	tflags;
#endif	PCAT
char term_buf[1024];
char cap_buf[2048];
char *cap_buf_p;
int LINES, COLS;
char *CM, *CL, *SO, *SE, *UE, *US, *CE, *VB;
int curx, cury;
int kanji_jis_mode = 0;
#ifdef _IBMR2
union txname savedtx;
char strBSD[] = "bsd";
#endif

kanji_in()
{
	if (!kanji_jis_mode) {
		kanji_jis_mode = TRUE;
		printf("%c$@", 27);
	}
}

kanji_out()
{
	if (kanji_jis_mode) {
		kanji_jis_mode = FALSE;
		printf("%c(J", 27);
	}
}

kanji_put(ch1, ch2)
int ch1, ch2;
{
	switch (kanji_code) {
	case KANJI_UJIS:
		putchar(ch1 | 0x80);
		putchar(ch2 | 0x80);
		break;
	case KANJI_SJIS:
		if (ch1 <= 0x5e) putchar((ch1-1)/2+0x71);
		else putchar((ch1-1)/2+0xb1);
		if (ch1 & 1) {
			if (ch2 >= 0x60) putchar(ch2+0x20);
			else putchar(ch2+0x1f);
		}
		else putchar(ch2+0x7e);
		break;
	case KANJI_JIS:
	default:
		kanji_in();
		putchar(ch1);
		putchar(ch2);
		break;
	}
}

int _putchar(c)
char c;
{
	putchar(c);
}

initscr()
{
	char *tgetstr();

#ifdef _IBMR2
	savedtx.tx_which = 0;
	ioctl(0, TXGETLD, &savedtx);
	if (strcmp(savedtx.tx_name, strBSD) != 0) {
	    ioctl(0, TXSETLD, strBSD);
	}
#endif
#ifdef	PCAT
	ioctl(0, TIOCGETA, &savets);
	ts = savets;
#else  !PCAT
	ioctl(0, TIOCGETC, &savetc);
	ioctl(0, TIOCGLTC, &savelt);
	ioctl(0, TIOCGETP, &savemode);
	tflags = savemode.sg_flags;
#endif	PCAT
	if (tgetent(term_buf, getenv("TERM")) != 1)
	  return ERR;
	cap_buf_p = cap_buf;
	LINES = tgetnum("li");
	COLS = tgetnum("co");
	if ((CM = tgetstr("cm", &cap_buf_p)) == NULL) return ERR;
	if ((CL = tgetstr("cl", &cap_buf_p)) == NULL) return ERR;
	if ((SO = tgetstr("so", &cap_buf_p)) == NULL) return ERR;
	if ((SE = tgetstr("se", &cap_buf_p)) == NULL) return ERR;
	if ((CE = tgetstr("ce", &cap_buf_p)) == NULL) return ERR;
	US = tgetstr("us", &cap_buf_p);
	UE = tgetstr("ue", &cap_buf_p);
	VB = tgetstr("vb", &cap_buf_p);
	clear();
	return OK;
}

endwin()
{
	kanji_out();
	return OK;
}

raw()
{
#ifdef	PCAT
	int i;
	
	ts.c_iflag = 0;
	ts.c_oflag = 0;
	ts.c_lflag = ISIG;
	for (i = 0; i < NCCS; i++) ts.c_cc[i] = 0;
	ts.c_cc[VINTR] = 'C'-'@';
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct	sgttyb	t;
	struct	ltchars	lt;
	struct  tchars tc;

	tc = savetc;
	tc.t_startc = tc.t_stopc = tc.t_eofc = tc.t_brkc = tc.t_quitc = -1;
	tc.t_intrc = 'C'-'@';
	ioctl(0, TIOCSETC, &tc);
	lt = savelt;
	lt.t_suspc = lt.t_dsuspc = lt.t_rprntc = lt.t_flushc = lt.t_werasc = lt.t_lnextc = -1;
	ioctl(0, TIOCSLTC, &lt);
	t = savemode;
	tflags |= CBREAK;
	tflags &= ~(RAW|XTABS);
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT
}

noraw()
{
#ifdef	PCAT
	ioctl(0, TIOCSETA, &savets);
#else  !PCAT
	ioctl(0, TIOCSETC, &savetc);
	ioctl(0, TIOCSLTC, &savelt);
	ioctl(0, TIOCSETP, &savemode);
#ifdef _IBMR2
	ioctl(0, TXSETLD, &savedtx);
#endif
#endif	PCAT

}

nl()
{
#ifdef	PCAT
	ts.c_iflag |= ICRNL;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags |= CRMOD;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT
}

nonl()
{
#ifdef	PCAT
	ts.c_iflag &= ~ICRNL;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags &= ~CRMOD;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT
}

echo()
{
#ifdef	PCAT
	ts.c_lflag |= ECHO;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags |= ECHO;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT
}

noecho()
{
#ifdef	PCAT
	ts.c_lflag &= ~ECHO;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags &= ~ECHO;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT
}

refresh()
{
	kanji_out();
	fflush(stdout);
}

mvprintw(y,x, fmt, a0, a1, a2, a3, a4, a5, a6, a7)
int y, x;
char *fmt;
{
	char buf[512], buf2[512];
	char *p, *q;
	int kanji, ch;

	kanji = 0;
	p = fmt;
	q = buf;
	while (ch = *p++) {
		if (ch == 27) /* ESC */ {
			kanji = !kanji;
		}
		else if (ch == '%' && kanji) {
			*q++ = '%';
		}
		*q++ = ch;
	}
	*q = 0;
	sprintf(buf2, buf, a0, a1, a2, a3, a4, a5, a6, a7);
	mvaddstr(y, x, buf2);
}

standout()
{
	kanji_out();
	tputs(SO, 0, _putchar);
}

standend()
{
	kanji_out();
	tputs(SE, 0, _putchar);
}

move(y,x)
int y, x;
{
	if (curx == x && cury == y) return;
	kanji_out();
	cury = y;
	curx = x;
	tputs(tgoto(CM, x, y), 0, _putchar);
}

printw(fmt, a0, a1, a2, a3, a4, a5, a6, a7)
char *fmt;
{
	char buf[512];

	sprintf(buf, fmt, a0, a1, a2, a3, a4, a5, a6, a7);
	addstr(buf);
}

mvaddstr(y, x, p)
int y, x;
char *p;
{
	move(y, x);
	addstr(p);
}

mvaddch(y, x, ch)
int y, x;
char ch;
{
	move(y, x);
	addch(ch);
}

addstr(p)
char *p;
{
	char ch;

	while (ch = *p++) addch(ch);
}

attrset(ul)
int ul;
{
	if (ul == A_UNDERLINE) {
		if (US) {
			kanji_out();
			tputs(US, 0, _putchar);
		}
	}
	else if (UE) {
		kanji_out();
		tputs(UE, 0, _putchar);
	}
}

clear()
{
	curx = cury = 0;
	kanji_out();
	tputs(CL, 0, _putchar);
}

clrtoeol()
{
	kanji_out();
	tputs(CE, 0, _putchar);
}

getch()
{
	kanji_out();
	return getchar();
}

addch(ch)
char ch;
{
	static int kanji = 0;
	static int kanji_first = 0;
	static int kanji_skip = 0;

	if (ch == 27) {
		kanji_skip = 2;
		kanji = !kanji;
	}
	else if (kanji_skip) {
		kanji_skip--;
	}
	else if (kanji || (ch & 0x80)) {
		if (kanji_first) {
			kanji_put(kanji_first, ch & 0x7f);
			kanji_first = 0;
			curx += 2;
		}
		else {
			kanji_first = ch & 0x7f;
		}
	}
	else {
		switch (ch) {
		      case '\n':
			clrtoeol();
			curx = 0;
			cury++;
			putchar('\r');
			putchar('\n');
			break;
		      case '\r':
			clrtoeol();
			curx = 0;
			cury++;
			putchar('\r');
			break;
		      case 'H'-'@':
			if (curx > 0) {
				curx--;
				putchar(ch);
			}
			break;
		      default:
			if (ch >= ' ') {
				kanji_out();
				putchar(ch);
				curx++;
			}
			break;
		}
	}
}

flash()
{
	kanji_out();
	if (VB) {
		tputs(VB, 0, _putchar);
	}
	else {
		putchar('G'-'@');
		fflush(stdout);
	}
}

#endif	NO_CURSES
